#	DataGram Viewer diagram
#
#	For CISE Project, CIS, OSU
#
#	by Shih-wei Li,   sli@cis.ohio-state.edu
#
#
proc make_viewer { name window_width x  y} {
    
    global VTextWidth VWidth VHeight VBase
    
    set VTextWidth 60
    set VWidth [expr ($window_width + $VTextWidth)]
    set VHeight 9000
    set VWHeight 200
    set VBase  10
    
    toplevel .viewer$name  
    
    wm geometry .viewer$name [expr $VWidth + 0]x$VWHeight+$x+$y
    wm title .viewer$name  "$name Packet Viewer"


    frame .viewer$name.drawingarea
    scrollbar .viewer$name.vscroll -command ".viewer$name.canvas yview"
    pack .viewer$name.vscroll -in .viewer$name.drawingarea -side right -fill y
   
    canvas .viewer$name.canvas \
	    -scrollregion "0 0 $VWidth $VHeight" \
	    -bg grey \
	    -relief sunken \
	    -borderwidth 1 \
	    -yscrollincrement 1 \
	    -yscrollcommand ".viewer$name.vscroll set"

    bind .viewer$name.canvas <2> ".viewer$name.canvas scan mark %x %y"
    bind .viewer$name.canvas <B2-Motion> ".viewer$name.canvas scan dragto %x %y"
    pack .viewer$name.canvas  -fill both -expand yes \
	    -in .viewer$name.drawingarea

    pack .viewer$name.drawingarea -fill both -expand yes
    

}

proc kill_viewer { name } {
    destroy .viewer$name
}

proc call_viewer { name ID offset length } {

    global VTextWidth VWidth VHeight VBase

# 
#   Draw the datagram 
#
    set i $offset 
    set y [expr ($VBase * $ID)]
    set y1 [expr ($y + $VBase)]

#    set frac [expr ($y - 150)/($VHeight * 1.0)]
#    .viewer$name.canvas yview moveto $frac

    .viewer$name.canvas create text 5 $y -text "ID: $ID" -fill white \
	    -anchor nw 

    .viewer$name.canvas create rec [expr ($offset + $VTextWidth)] $y \
	    [expr ($offset + $length + $VTextWidth)]  $y1 \
	    -fill yellow -outline red -width 1
    
}













